#
# The external Ingress is for the public facing site. This ingress may have PKIo or LetsEncrypt certs, depending on the configuration.
#
# For admin and API access, as well as internal connections, we use the admin ingress. This ingress will use LetsEncrypt certs from the cert manager.
#

- name: Admin Ingress
  k8s:
    state: present
    force: true # make sure removals from annotations are reflected
    definition:
      apiVersion: networking.k8s.io/v1
      kind: Ingress
      metadata:
        annotations:
          kubernetes.io/ingress.class: nginx
          cert-manager.io/cluster-issuer: "{{ config.certmanager.issuer | default('none') }}"
          nginx.ingress.kubernetes.io/proxy-body-size: 512m
          nginx.ingress.kubernetes.io/proxy-connect-timeout: "15"
          nginx.ingress.kubernetes.io/proxy-read-timeout: "600"
          nginx.ingress.kubernetes.io/whitelist-source-range: "{{ config.gitlab.whitelist_source_range_admin | default(omit) }}"
          nginx.ingress.kubernetes.io/proxy-request-buffering: "off"
        name: "gitlab-webservice-admin"
        namespace: "{{ config.gitlab.namespace }}"
      spec:
        rules:
        - host: "{{ config.gitlab.fqdn }}"
          http:
            paths:
            - backend:
                service:
                  name: gitlab-webservice-default
                  port:
                    number: 8181
              path: /
              pathType: Prefix
            - backend:
                service:
                  name: gitlab-webservice-default
                  port:
                    number: 8080
              path: /admin/sidekiq
              pathType: Prefix
        tls:
        - hosts:
          - "{{ config.gitlab.fqdn }}"
          secretName: gitlab-admin-tls
  when:
    - config.gitlab.use_v1_ingress | default(true)

- name: Admin Ingress old style
  k8s:
    state: present
    force: true # make sure removals from annotations are reflected
    definition:
      apiVersion: "extensions/v1beta1"
      kind: Ingress
      metadata:
        annotations:
          kubernetes.io/ingress.class: nginx
          cert-manager.io/cluster-issuer: "{{ config.certmanager.issuer | default('none') }}"
          nginx.ingress.kubernetes.io/proxy-body-size: 512m
          nginx.ingress.kubernetes.io/proxy-connect-timeout: "15"
          nginx.ingress.kubernetes.io/proxy-read-timeout: "600"
          nginx.ingress.kubernetes.io/whitelist-source-range: "{{ config.gitlab.whitelist_source_range_admin | default(omit) }}"
          nginx.ingress.kubernetes.io/proxy-request-buffering: "off"
        name: "gitlab-webservice-admin"
        namespace: "{{ config.gitlab.namespace }}"
      spec:
        rules:
          - host: "{{ config.gitlab.fqdn }}"
            http:
              paths:
                - backend:
                    serviceName: gitlab-webservice-default
                    servicePort: 8181
                  path: /
                - backend:
                    serviceName: gitlab-webservice-default
                    servicePort: 8080
                  path: /admin/sidekiq
        tls:
          - hosts:
              - "{{ config.gitlab.fqdn }}"
            secretName: gitlab-admin-tls
  when:
    - not (config.gitlab.use_v1_ingress | default(true))
